<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\effective;


use app\adminapi\lists\BaseAdminDataLists;
use app\adminapi\logic\effective\OrderEffectiveLogLogic;
use app\common\model\orders\OrderEffectiveLog;
use app\common\lists\ListsSearchInterface;
use app\common\model\user\User;
use app\common\model\works\ServiceWork;


/**
 * OrderEffectiveLog列表
 * Class OrderEffectiveLogLists
 * @package app\adminapi\lists
 */
class OrderEffectiveLogLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2025/01/17 11:10
     */
    public function setSearch(): array
    {
        if(isset($this->params['mobile']) && !empty($this->params['mobile'])){
            $userIds = User::whereLike('mobile',"%{$this->params['mobile']}%")->column('id')??[0];
            $this->params['user_id'] = $userIds;
        }

        return [
            '=' => ['effective_id', 'sn', 'work_id', 'goods_id', 'effective_unit', 'effective_num', 'remark', 'end_effective_time','effective_status'],
            'in' => ['user_id']
        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2025/01/17 11:10
     */
    public function lists(): array
    {
        $list = OrderEffectiveLog::with(['goods'=>function ($query) {
                $query->with(['goodsCategory'=>function ($query1) {
                    $query1->field(['name','picture']);
                }]);
            },'serviceWork','originalServiceWork','userInfo'])->where('effective_status','>',0)->where($this->searchWhere)
            ->field(['*'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();

        foreach ($list as &$value) {
            $value['income_fee'] = 0;
            if($value['originalServiceWork']) $value['income_fee'] = OrderEffectiveLogLogic::commissionAndAssuranceDeposit($value['originalServiceWork']);
        }
        return $list;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2025/01/17 11:10
     */
    public function count(): int
    {
        return OrderEffectiveLog::where($this->searchWhere)->count();
    }

}